searchData={"items":[{"type":"module","doc":"Documentation for `Conion`'s main API.","title":"Conion","ref":"Conion.html"},{"type":"function","doc":"alive? returns true if the Conion.Server and all it's children are running.","title":"Conion.alive?/0","ref":"Conion.html#alive?/0"},{"type":"function","doc":"Return the list of children, that should be started with the `Conion.Application`.","title":"Conion.application_children/0","ref":"Conion.html#application_children/0"},{"type":"function","doc":"All confiurations are loaded fro ENV vars. Where the default value for each key is \nconfigured in the application's configuration.","title":"Conion.configurations/0","ref":"Conion.html#configurations/0"},{"type":"function","doc":"Load the configuration from ENV and config.exs and call the \nsetup functions for each configuration key.\nReturns a map with {ENV, return_from_load_configuration_for/2}","title":"Conion.configure/0","ref":"Conion.html#configure/0"},{"type":"module","doc":"Configures the application and starts the supervision tree.\n\nWhich supervised children to start is configured in the `config.exs` file\nand pulled in from `Conion.application_children/0`.","title":"Conion.Application","ref":"Conion.Application.html"},{"type":"module","doc":"Wrapper around the default `Logger`. Always use the\nElixir.Conion.Common.CentralLogger.log/1 to do logging. This ensures all\nlog messages are formatted the same and are easy to \nread and configure in a single place.\n\nYou can also `use CentralLogger` to import the `log/3`\nfunction into your module.","title":"Conion.Common.CentralLogger","ref":"Conion.Common.CentralLogger.html"},{"type":"function","doc":"Call the system's `Logger.configure/1` function.","title":"Conion.Common.CentralLogger.configure/1","ref":"Conion.Common.CentralLogger.html#configure/1"},{"type":"function","doc":"The `element` is passed through the function, so you can\nuse this function in a pipe.\n\n  `element` ..... the element to log and return at the end\n  `level` ....... log in which LOG_LEVEL\n  `message` ..... the text to prepend to the element inspect","title":"Conion.Common.CentralLogger.log/3","ref":"Conion.Common.CentralLogger.html#log/3"},{"type":"module","doc":"General functions to deal with runtime configuration","title":"Conion.Common.Configuration","ref":"Conion.Common.Configuration.html"},{"type":"function","doc":"Same as `load!/1` but rescue from raise and returns a \nerror tuple `{:error, err}`.","title":"Conion.Common.Configuration.load/1","ref":"Conion.Common.Configuration.html#load/1"},{"type":"function","doc":"Loads the environment ENV from `env`. If it is not\ndefined, returns the mix-configuration for `app`,\n`key`, `default`. The !-version may raise errors.","title":"Conion.Common.Configuration.load!/1","ref":"Conion.Common.Configuration.html#load!/1"},{"type":"function","doc":"Loads the configuration for a given key `{_env, _app, _key, _default}` and\ncalls the `set_function/1` with the loaded value.","title":"Conion.Common.Configuration.load_configuration_for/2","ref":"Conion.Common.Configuration.html#load_configuration_for/2"},{"type":"function","doc":"Set the log-level. You can pass one of the following values.\nEither as binary or atom: notice, debug, warning, error","title":"Conion.Common.Configuration.set_log_level/1","ref":"Conion.Common.Configuration.html#set_log_level/1"},{"type":"behaviour","doc":"`use CommonServer` defines some boilerplate functions for a GenServer.","title":"Conion.CommonServer","ref":"Conion.CommonServer.html"},{"type":"callback","doc":"","title":"Conion.CommonServer.initial_state/1","ref":"Conion.CommonServer.html#c:initial_state/1"},{"type":"callback","doc":"","title":"Conion.CommonServer.prepare_start/1","ref":"Conion.CommonServer.html#c:prepare_start/1"},{"type":"module","doc":"The API for the store components `Conion.Store.Server`\nand `Conion.Store.Bucket`.\n\nAlso see the `Behaviour` defined in `Conion.Store.Persistor`","title":"Conion.Store","ref":"Conion.Store.html"},{"type":"function","doc":"returns true if the given bucket is not saved permanently","title":"Conion.Store.dirty?/1","ref":"Conion.Store.html#dirty?/1"},{"type":"function","doc":"Get the entry with the given id from the bucket","title":"Conion.Store.get/2","ref":"Conion.Store.html#get/2"},{"type":"function","doc":"Insert a new entry into an existing bucket","title":"Conion.Store.insert_new/2","ref":"Conion.Store.html#insert_new/2"},{"type":"function","doc":"List all entries from the bucket `[{id,entry},...]`","title":"Conion.Store.list/1","ref":"Conion.Store.html#list/1"},{"type":"function","doc":"List all available buckets","title":"Conion.Store.list_buckets/0","ref":"Conion.Store.html#list_buckets/0"},{"type":"function","doc":"Create or load a new bucket","title":"Conion.Store.new_bucket/1","ref":"Conion.Store.html#new_bucket/1"},{"type":"function","doc":"Create or load a new bucket with a persistor","title":"Conion.Store.new_bucket/3","ref":"Conion.Store.html#new_bucket/3"},{"type":"function","doc":"persist the bucket","title":"Conion.Store.persist/1","ref":"Conion.Store.html#persist/1"},{"type":"function","doc":"Returns the persistor of a bucket","title":"Conion.Store.persistor/1","ref":"Conion.Store.html#persistor/1"},{"type":"function","doc":"remove entry with the given id","title":"Conion.Store.remove/2","ref":"Conion.Store.html#remove/2"},{"type":"function","doc":"Update replace the entry at the given id with the new entry","title":"Conion.Store.replace/3","ref":"Conion.Store.html#replace/3"},{"type":"function","doc":"Sorts the list of buckets `[{id,entry}, {id, entry}, ...]` by the given function","title":"Conion.Store.sort_by/2","ref":"Conion.Store.html#sort_by/2"},{"type":"module","doc":"A Bucket is a key/value store in a supervised GenServer.\nUse `Conion.Store.new_bucket/1` to start a bucket.\nThe Server will use `Conion.Store.BucketSupervisor.start_child/1`\nto do so.","title":"Conion.Store.Bucket","ref":"Conion.Store.Bucket.html"},{"type":"function","doc":"Return the bucket name of the bucket at `pid`","title":"Conion.Store.Bucket.bucket_name/1","ref":"Conion.Store.Bucket.html#bucket_name/1"},{"type":"function","doc":"safely call the GenServer.callback \nreturn an error tuple if the bucket is not alive","title":"Conion.Store.Bucket.call/2","ref":"Conion.Store.Bucket.html#call/2"},{"type":"function","doc":"","title":"Conion.Store.Bucket.call_or_error/3","ref":"Conion.Store.Bucket.html#call_or_error/3"},{"type":"function","doc":"safely cast the GenServer.callback \nreturn an error tuple if the bucket is not alive","title":"Conion.Store.Bucket.cast/2","ref":"Conion.Store.Bucket.html#cast/2"},{"type":"function","doc":"","title":"Conion.Store.Bucket.cast_or_error/3","ref":"Conion.Store.Bucket.html#cast_or_error/3"},{"type":"function","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","title":"Conion.Store.Bucket.child_spec/1","ref":"Conion.Store.Bucket.html#child_spec/1"},{"type":"function","doc":"Retrun true if the bucket is not stored permanently","title":"Conion.Store.Bucket.dirty?/1","ref":"Conion.Store.Bucket.html#dirty?/1"},{"type":"function","doc":"removes all entries from the bucket","title":"Conion.Store.Bucket.drop!/1","ref":"Conion.Store.Bucket.html#drop!/1"},{"type":"function","doc":"Return the entry at id from the bucket","title":"Conion.Store.Bucket.get/2","ref":"Conion.Store.Bucket.html#get/2"},{"type":"function","doc":"Returns the state of a server. You can pass an atom or pid.","title":"Conion.Store.Bucket.get_state/1","ref":"Conion.Store.Bucket.html#get_state/1"},{"type":"function","doc":"Overridable:\n\nPrepares, validates, formats the given state to be passed to init()","title":"Conion.Store.Bucket.initial_state/1","ref":"Conion.Store.Bucket.html#initial_state/1"},{"type":"function","doc":"`{:ok, {new_id,etry}}, {:error, :bucket_not_exist}`","title":"Conion.Store.Bucket.insert/2","ref":"Conion.Store.Bucket.html#insert/2"},{"type":"function","doc":"Return all entry from the bucket","title":"Conion.Store.Bucket.list/1","ref":"Conion.Store.Bucket.html#list/1"},{"type":"function","doc":"Persist a bucket","title":"Conion.Store.Bucket.persist/1","ref":"Conion.Store.Bucket.html#persist/1"},{"type":"function","doc":"return the bucket's persistor","title":"Conion.Store.Bucket.persistor/1","ref":"Conion.Store.Bucket.html#persistor/1"},{"type":"function","doc":"Overridable:\n\nShould return the args passed to start_link. For a named server it extracts\nthe :initial_state from the `opts`. For unnamed processes it takes `opts` as the initial state.","title":"Conion.Store.Bucket.prepare_state_to_start/1","ref":"Conion.Store.Bucket.html#prepare_state_to_start/1"},{"type":"function","doc":"`{:ok, {id,etry}}, {:error, :bucket_not_exist | :id_not_found}`","title":"Conion.Store.Bucket.remove/2","ref":"Conion.Store.Bucket.html#remove/2"},{"type":"function","doc":"`{:ok, {id,etry}}, {:error, :bucket_not_exist | :id_not_found}`","title":"Conion.Store.Bucket.replace/3","ref":"Conion.Store.Bucket.html#replace/3"},{"type":"function","doc":"Start the server with either\n\n    MyServer.start_link(initial_state) ... start an unregistered server with the given \n                                           initial state.\n\n    MyServer.start_link(name: :registered_as_whatever, initial_state: any) ...\n                                           start a registered server with `initial_state` as it's state.","title":"Conion.Store.Bucket.start_link/1","ref":"Conion.Store.Bucket.html#start_link/1"},{"type":"module","doc":"A `DynamicSupervisor` whith `Bucket` children.","title":"Conion.Store.BucketSupervisor","ref":"Conion.Store.BucketSupervisor.html"},{"type":"function","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","title":"Conion.Store.BucketSupervisor.child_spec/1","ref":"Conion.Store.BucketSupervisor.html#child_spec/1"},{"type":"function","doc":"Returns a list of bucket-names of all Buckets alive.","title":"Conion.Store.BucketSupervisor.list_buckets/0","ref":"Conion.Store.BucketSupervisor.html#list_buckets/0"},{"type":"function","doc":"Starts a new Bucket if not running yet.\nReturns {:ok, pid}","title":"Conion.Store.BucketSupervisor.start_child/1","ref":"Conion.Store.BucketSupervisor.html#start_child/1"},{"type":"function","doc":"Started from `Conion.Application`","title":"Conion.Store.BucketSupervisor.start_link/1","ref":"Conion.Store.BucketSupervisor.html#start_link/1"},{"type":"behaviour","doc":"Persistor is a behaviour which implements the low-level read! and write! functions\nto store any kind of data to any kind of storage.","title":"Conion.Store.Persistor","ref":"Conion.Store.Persistor.html"},{"type":"callback","doc":"Reads any kind of data from a store with any name \nand returns the read data or raises an exception.","title":"Conion.Store.Persistor.read!/1","ref":"Conion.Store.Persistor.html#c:read!/1"},{"type":"callback","doc":"Writes any kind of data to a store with any name and returns `:ok`\nor raises an exception.","title":"Conion.Store.Persistor.write!/2","ref":"Conion.Store.Persistor.html#c:write!/2"},{"type":"module","doc":"Persists and reads data to raw files.","title":"Conion.Store.Persistor.File","ref":"Conion.Store.Persistor.File.html"},{"type":"function","doc":"Read data from filename and returns data on success.\nOtherwise raises an exception from `File.read!/1`","title":"Conion.Store.Persistor.File.read!/1","ref":"Conion.Store.Persistor.File.html#read!/1"},{"type":"function","doc":"Write data to filename and returns :ok on success.\nOtherwise raises an exception from `File.write!/3`","title":"Conion.Store.Persistor.File.write!/2","ref":"Conion.Store.Persistor.File.html#write!/2"},{"type":"module","doc":"Conion's Store Server (DataGateway)","title":"Conion.Store.Server","ref":"Conion.Store.Server.html"},{"type":"function","doc":"safely call the GenServer.callback \nreturn an error tuple if the bucket is not alive","title":"Conion.Store.Server.call/2","ref":"Conion.Store.Server.html#call/2"},{"type":"function","doc":"","title":"Conion.Store.Server.call_or_error/3","ref":"Conion.Store.Server.html#call_or_error/3"},{"type":"function","doc":"safely cast the GenServer.callback \nreturn an error tuple if the bucket is not alive","title":"Conion.Store.Server.cast/2","ref":"Conion.Store.Server.html#cast/2"},{"type":"function","doc":"","title":"Conion.Store.Server.cast_or_error/3","ref":"Conion.Store.Server.html#cast_or_error/3"},{"type":"function","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","title":"Conion.Store.Server.child_spec/1","ref":"Conion.Store.Server.html#child_spec/1"},{"type":"function","doc":"Returns the state of a server. You can pass an atom or pid.","title":"Conion.Store.Server.get_state/1","ref":"Conion.Store.Server.html#get_state/1"},{"type":"function","doc":"Overridable:\n\nPrepares, validates, formats the given state to be passed to init()","title":"Conion.Store.Server.initial_state/1","ref":"Conion.Store.Server.html#initial_state/1"},{"type":"function","doc":"Overridable:\n\nShould return the args passed to start_link. For a named server it extracts\nthe :initial_state from the `opts`. For unnamed processes it takes `opts` as the initial state.","title":"Conion.Store.Server.prepare_state_to_start/1","ref":"Conion.Store.Server.html#prepare_state_to_start/1"},{"type":"function","doc":"Start the server with either\n\n    MyServer.start_link(initial_state) ... start an unregistered server with the given \n                                           initial state.\n\n    MyServer.start_link(name: :registered_as_whatever, initial_state: any) ...\n                                           start a registered server with `initial_state` as it's state.","title":"Conion.Store.Server.start_link/1","ref":"Conion.Store.Server.html#start_link/1"},{"type":"extras","doc":"# Conion\n\n[![.github/workflows/elixir.yml](https://github.com/iboard/conion/actions/workflows/elixir.yml/badge.svg)](https://github.com/iboard/conion/actions/workflows/elixir.yml)\n\nConion is a package containing an Elixir application that provides some \ncommon modules for general tasks in your Elixir application.\n\n**At the moment, this is just a POC. Lets see how mature this application can get.**","title":"Conion","ref":"readme.html"},{"type":"extras","doc":"- A key/value store (`Conion.Store`) that handles `Conion.Store.Bucket`s\n  - The `Conion.Store.Persistor` is a `Behaviour` that implements `read!` and `write!`\n    for those buckets.\n- Buckets are supervised\n- A central `Conion.Common.Configuration` module to deal with compile and runtime\n  configuration.\n- A central `Conion.Common.CentralLogger` module to do logging in a common manner.\n\n...more to come","title":"A persistent, supervised key/value store - Conion","ref":"readme.html#a-persistent-supervised-key-value-store"},{"type":"extras","doc":"git clone https://github.com/iboard/conion.git\n    cd conion\n    mkdir -p data/test data/dev\n    mix test","title":"Install and prepare - Conion","ref":"readme.html#install-and-prepare"},{"type":"extras","doc":"```\n  defp deps do\n    [\n      { :conion, \"~> 0.1\"}\n    ]\n\n```","title":"Use it as a dependency in your `mix.exs` - Conion","ref":"readme.html#use-it-as-a-dependency-in-your-mix-exs"},{"type":"extras","doc":"","title":"Usage Examples - Conion","ref":"readme.html#usage-examples"},{"type":"extras","doc":"Define the following function in your top module\n\n```\n  def configurations,\n    do: [\n      # { {ENV,      :app,    :key, default}, set-function/1                }\n      {{\"LOG_LEVEL\", :logger, :level, :info}, &Configuration.set_log_level/1}\n    ]\n```\n\nand use it like\n\n```\n  def configure(),\n    do:\n      configurations()\n      |> Enum.reduce(%{}, &Configuration.load_configuration_for/2)\n\n```","title":"Configuration - Conion","ref":"readme.html#configuration"},{"type":"extras","doc":"```\n  use Conion.Common.CentralLogger\n  \n  def .... do \n    log(element_to_log, :warning, \"Any message\" )\n  end\n```\n\n`:warning` is an example for any log-level (:info, :notice, :warning, :error, ...)\nThe `element_to_log` will be \"inspected\" and passed through, thus you can use this\nlog-function in a pipe.","title":"CentralLogger - Conion","ref":"readme.html#centrallogger"},{"type":"extras","doc":"To define your GenServers use ...\n\n```\n  use Conion.CommonServer\n  \n  def prepare_state_to_start(args) do\n    # define any term that will be passed to `start_link(__MODULE__, state)` as\n    # the initial state passed to GenServer's `init` function.\n  end\n\n  def initial_state(init_state_from_prepare_function) do\n    # complete the \"loading\", \"initializing\" in the GenServer's init-callback here.\n  end\n\n  # use the `call/2` function to safely call a \"handle_call\" or \"handle_cast\"\n  def bucket_name(pid), do: call(pid, :bucket_name)\n  def persist(bucket), do: cast(process_name(bucket), :persist)\n  \n  # and implement the callbacks as usual\n  def handle_call(:bucket_name, _, state), do: calculate_the_return; {:reply, state[:name], state}\n  def handle_cast(:persist, state), do: do_something; {:noreply, state}\n```","title":"CommonServer - Conion","ref":"readme.html#commonserver"},{"type":"extras","doc":"`Store.Persistor.File` is a simple implementation of the `Store.Persistor` behaviour\nthat writes the data into the given file, using `:erlang.term_to_binary` and reads it back\nusing `:erlang.binary_to_term`\n\nMore implementations of \"persistors\" will follow.\n\n```\nalias CentralScrutinizer.Store\nStore.new_bucket :family, Store.Persistor.File, filename: \"data/dev/family.data\"\n# where `Store.Persistor.File` implements the `Persistor`-behaviour and writes the data to the\n# given file.\n\n{:ok, id_father} = Store.insert_new(:family, %{ name: \"Father\", age: 50})\n{:ok, id_mother} = Store.insert_new(:family, %{ name: \"Mother\", age: 45})\n{:ok, id_child} = Store.insert_new(:family, %{ name: \"Child\", age: 5})\nStore.list(:family)\n# [ {id, %{...}}, {id, %{...}}, ...]\nStore.replace(:family, id_father, %{ name: \"Papa\", age: 51})\nStore.get(:family, id_father) # => %{ name: \"Papa\", age: 51}\nStore.remove(:family, id_father)\nStore.persist(:family)\n\n```","title":"Store - Conion","ref":"readme.html#store"},{"type":"extras","doc":"to create an xref-graph use the following command:\n\n    mix xref graph --format dot  && \\\n    dot -Tpng xref_graph.dot -o xref_graph.png && \\\n    open xref_graph.png && \\\n    sleep 5 && rm xref_graph.*","title":"Generate an XREF image - Conion","ref":"readme.html#generate-an-xref-image"},{"type":"extras","doc":"mix docs && open doc/index.html","title":"Generate documentation - Conion","ref":"readme.html#generate-documentation"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.36.1"}}